#ifndef _TS_Bus_H
#define _TS_Bus_H

#include "Prefix.h"
#include "EARTH_PT.h"
#include "TS_Device.h"
#include "TS_Utility.h"

namespace EARTH{
namespace TS{
	class Bus{
	public:
		Bus(){mBus = NULL;}

		~Bus(){
			if(mBus){
				status status = mBus->Delete();
				if(Error(L"Bus::Delete()", status))	return;
				mBus = NULL;
			}
		}

		void Run(PT::Bus::NewBusFunction function){
			status status = function(&mBus);
			if(Error(L"Bus::Run()",status))	return;

			PT::Bus::DeviceInfo deviceInfo[9];
			uint deviceInfoCount = sizeof(deviceInfo)/sizeof(*deviceInfo);
			mBus->Scan(deviceInfo,&deviceInfoCount,deviceInfoCount);

			for(;;) {
				::wprintf(L"[foCXIj[]\n");
				::wprintf(L"   Dev1:  Dev2:  Dev3:  Dev4:\n");
				for(uint i = 0; i < deviceInfoCount; ++i){
					const PT::Bus::DeviceInfo *info = deviceInfo + i;
					::wprintf(L"%d: %s %s %s %s\n",i,info->DevName[0],info->DevName[1],info->DevName[2],info->DevName[3]);
				}
				::wprintf(L"%d: I\n", deviceInfoCount);
				::wprintf(L">");
				uint number = GetNumber(deviceInfoCount);
				if(number == deviceInfoCount)	break;
				else{
					TS::Device *tsDevice = new TS::Device();
					tsDevice->Run(mBus,&deviceInfo[number]);
					delete_(tsDevice);
				}
			}
		}

	protected:
		PT::Bus *mBus;
	};
}
}

#endif
